<template>
  <column
    v-if="loggedOut"
    class="fixed-full login-signup centered narrow hero-bg"
  >
    <column class="padding-between dark-bg">
      <cell>
        <h1>orienteer</h1>
        <p>An online training tool for orienteers.</p>
      </cell>
      <login-widget login />
    </column>
  </column>
  <column v-else class="fixed-full" :class="routeClass">
    <row class="header space-between">
      <row class="links">
        <cell class="hamburger">
          <i
            v-if="contentHidden"
            class="el-icon-s-unfold"
            @click="contentHidden = false"
          />
          <i v-else class="el-icon-s-fold" @click="contentHidden = true" />
        </cell>
        <cell class="logo">
          <nuxt-link class="pill" to="/">orienteer</nuxt-link>
        </cell>
      </row>
      <row class="links">
        <!--<cell>
          <nuxt-link to="/debug-maps">DEBUG</nuxt-link>
        </cell> -->
        <cell>
          <el-popover placement="bottom" trigger="click" class="help-popper">
            <a slot="reference" class="pill">?</a>
            <help-content />
          </el-popover>
        </cell>
        <upgrade-cta />
        <profile-button />
      </row>
    </row>
    <div class="default-layout-map-container">
      <client-only>
        <MglMap
          ref="map"
          :mapStyle="mapStyle"
          :doubleClickZoom="false"
          accessToken="pk.eyJ1IjoiZHN0YXVkaWdlbCIsImEiOiJjazNueTNoNm0xdjZ5M2ZudXY3ZWN4aW0xIn0.tCf460GP2JsHd1DxJ-nMNA"
          :bearing="bearing"
          :dragRotate="false"
          :touchZoomRotate="false"
          @moveend="moveEnd"
        >
          <portal-target name="map-controls">
            <MglScaleControl position="bottom-right" />
            <MglNavigationControl position="bottom-right" />
            <MglGeolocateControl position="bottom-right" />
          </portal-target>

          <portal-target name="map" multiple />
        </MglMap>
      </client-only>
    </div>
    <client-only
      ><div class="run-preventer" v-if="activeRun && !running">
        <run-dialog /></div
    ></client-only>

    <nuxt class="main-nuxt" :class="{ 'content-hidden': contentHidden }" />
  </column>
</template>
<script>
import ProfileButton from "~/components/ProfileButton";
import * as UTM from "utm";
import RunDialog from "./-RunDialog";
import { mapState } from "vuex";
import style from "~/lib/display-style/style";

export default {
  data() {
    return {
      mapStyle: JSON.parse(JSON.stringify(style)),
      bearing: 0,
      contentHidden: false,
    };
  },
  components: {
    ProfileButton,
    "upgrade-cta": () =>
      import("~/components/UpgradeCTA").then((r) => r.default),
    "run-dialog": RunDialog,
    "login-widget": () =>
      import("~/components/LoginWidget").then((r) => r.default || r),
    "help-content": () =>
      import("~/components/HelpContent").then((r) => r.default || r),
  },
  computed: {
    ...mapState({
      loggedOut: (state) => !(state.user && state.user.id),
      user: (state) => state.user,
    }),
    routeClass() {
      const p = this.$route.path.replace(/^\//, "").replace(/\//g, "--");

      return `route__${p}`;
    },
    activeRun() {
      return !!(this.$store.state.run.courseId && this.$store.state.run.start);
    },
    running() {
      return this.$route.path.match(/^\/run/);
    },
  },
  mounted() {
    if (module.hot) {
      module.hot.accept(
        [
          "~/lib/display-style/style",
          "~/lib/map-style/thunderforest/index",
          "~/lib/map-style/mapbox-outdoor/index",
        ],
        () => {
          console.log("UPDATED STYLE JSON");
          this.mapStyle = JSON.parse(JSON.stringify(style));
        }
      );
    }
  },
  methods: {
    moveEnd(event) {
      let center = event.map.getCenter();

      const a = UTM.fromLatLon(center.lat, center.lng);
      const b = UTM.fromLatLon(center.lat + 0.001, center.lng);

      const n = a.northing - b.northing;
      const e = a.easting - b.easting;

      const r = 90 + (Math.atan2(n, e) * 180) / Math.PI;

      // it really is disconcerting to have it rotate as much as it does:
      // this.bearing = r;
    },
  },
};
</script>
<style lang="scss">
@import "~assets/global";

.fixed-full .header .hamburger {
  @media (min-width: 500px) {
    display: none;
  }

  padding-right: $grid;
}

.ui-column.fixed-full.login-signup {
  z-index: 1000;

  top: $grid * 2;
  max-height: 70vh;

  overflow-y: auto;
}

.main-nuxt {
  z-index: 5;
  display: inline-block;
  pointer-events: none;

  & > div {
    pointer-events: initial;

    background-color: $color-background;
    max-height: 90vh;
    max-width: unquote("min(90vw, #{$grid * 15})");
    overflow-y: auto;

    padding: $grid * 0.5;

    transition: transform 250ms ease-in-out;
  }

  @media (max-width: 499px) {
    &.content-hidden > div {
      transform: translateX(-100%);
    }
    &.content-hidden.no-hide > div {
      transform: translateX(0);
    }
  }
}

.run-preventer {
  pointer-events: initial;
}

.logo a {
  color: $color-brand-primary;
  text-transform: uppercase;
  text-shadow: 8px rgba(0, 0, 0, 0.75);
  font-weight: 800;
  padding: 0 $grid * 0.5;
  &:hover {
    text-decoration: none;
  }
}

.header {
  z-index: 10;
  height: $grid * 2;
  pointer-events: none;
  background-color: $color-background;
}

.fixed-full {
  pointer-events: initial;
}

.pill {
  @include corners($grid, $grid, $grid, $grid);
  min-width: $grid * 1.25;
  min-height: $grid * 1.25;
  vertical-align: middle;
  line-height: $grid * 1.25;
  display: inline-block;

  // padding: 0 $grid*0.25;

  background-color: $color-background;
  text-align: center;
}

.links {
  pointer-events: initial;
  .ui-cell {
    display: flex;

    justify-content: center;
    align-items: center;

    height: $grid * 2;

    padding: 0 0 0 $grid * 0.5;
  }
}

.dark-bg {
  background: $color-background;
  padding: $grid * 2;
  border-radius: $grid;
  pointer-events: initial;
}

.default-layout-map-container {
  position: absolute;
  top: 0;
  left: 0;
  bottom: 0;
  right: 0;
}
</style>
